Index: extensions/app_diameap/diameap_server.c
===================================================================
--- extensions/app_diameap/diameap_server.c	(revision 425)
+++ extensions/app_diameap/diameap_server.c	(revision 438)
@@ -3315,8 +3048,336 @@
 }
 
+
+
+
+static int diameap_server_callback(struct msg ** rmsg, struct avp * ravp,
+		struct session * sess, enum disp_action * action)
+{
+	TRACE_ENTRY("%p %p %p %p", rmsg, ravp, sess, action);
+
+	struct diameap_sess_data_sm * diameap_sess_data = NULL;
+	struct diameap_state_machine * diameap_sm = NULL;
+	struct diameap_eap_interface eap_i;
+	struct msg *req, *ans;
+	boolean non_fatal_error = FALSE;
+
+	if (rmsg == NULL)
+		return EINVAL;
+
+	req = *rmsg;
+
+	CHECK_FCT_DO(fd_sess_state_retrieve(diameap_server_reg, sess, &diameap_sess_data),
+			{	TRACE_DEBUG(INFO,"%s retrieving session state failed.",DIAMEAP_EXTENSION); goto s_end;});
+
+	CHECK_MALLOC_DO(diameap_sm = malloc(sizeof(struct diameap_state_machine)),
+			goto s_end);
+	memset(diameap_sm, 0, sizeof(struct diameap_state_machine));
+
+	if (diameap_sess_data)
+	{
+		diameap_sm->state = DIAMEAP_RECEIVED;
+		diameap_sm->eap_sm.eap_state = EAP_IDLE;
+	}
+	else
+	{
+		diameap_sm->state = DIAMEAP_DISABLED;
+		diameap_sm->eap_sm.eap_state = EAP_INITIALIZE;
+	}
+
+	while (diameap_sm->state != DIAMEAP_IDLE && diameap_sm->state
+			!= DIAMEAP_END)
+	{
+		switch (diameap_sm->state)
+		{
+		case DIAMEAP_DISABLED:
+			if (rmsg)
+			{
+				diameap_sm->state = DIAMEAP_INITIALIZE;
+			}
+			else
+			{
+				TRACE_DEBUG(INFO,"%sReceived empty Diameter EAP Request message.",DIAMEAP_EXTENSION);
+				goto s_end;
+			}
+			break;
+
+		case DIAMEAP_INITIALIZE:
+
+			CHECK_FCT_DO(diameap_initialize_diameap_sm(diameap_sm,diameap_sess_data),
+					{	TRACE_DEBUG(INFO,"%s Initializing DiamEAP state machine failed.",DIAMEAP_EXTENSION); goto s_end;})
+			;
+			CHECK_FCT_DO(diameap_initialize_diameap_eap_interface(&eap_i),
+					{	TRACE_DEBUG(INFO,"%s Initializing DiamEAP-EAP Interface failed.",DIAMEAP_EXTENSION); goto s_end;})
+			;
+			TRACE_DEBUG(FULL+1,"%sParsing AVPs",DIAMEAP_EXTENSION)
+			;
+			CHECK_FCT_DO(diameap_parse_avps(diameap_sm, req, &eap_i), TRACE_DEBUG(INFO,"%s Unable to parse Diameter-EAP-Request AVPs.",DIAMEAP_EXTENSION))
+			;
+
+			if ((diameap_sm->result_code != 0))
+			{
+				diameap_sm->state = DIAMEAP_SEND_ERROR_MSG;
+			}
+			else
+			{
+				diameap_sm->state = DIAMEAP_AUTHENTICATION_VERIFY;
+			}
+			break;
+
+		case DIAMEAP_RECEIVED:
+
+			CHECK_FCT_DO(diameap_initialize_diameap_sm(diameap_sm,diameap_sess_data),
+					{	TRACE_DEBUG(INFO,"%s Initializing DiamEAP state machine failed.",DIAMEAP_EXTENSION); goto s_end;})
+			;
+			CHECK_FCT_DO(diameap_initialize_diameap_eap_interface(&eap_i),
+					{	TRACE_DEBUG(INFO,"%s Initializing DiamEAP-EAP Interface failed.",DIAMEAP_EXTENSION); goto s_end;})
+			;
+			TRACE_DEBUG(FULL+1,"%sParsing AVPs",DIAMEAP_EXTENSION)
+			;
+			CHECK_FCT_DO(diameap_parse_avps(diameap_sm, req, &eap_i), TRACE_DEBUG(INFO,"%s Unable to parse Diameter-EAP-Request AVPs.",DIAMEAP_EXTENSION))
+			;
+
+			if (diameap_sm->result_code != 0)
+			{
+				diameap_sm->state = DIAMEAP_SEND_ERROR_MSG;
+			}
+			else
+			{
+				diameap_sm->state = DIAMEAP_AUTHENTICATION_VERIFY;
+			}
+			break;
+
+		case DIAMEAP_AUTHENTICATION_VERIFY:
+		{
+
+			TRACE_DEBUG(FULL+1,"%sVerify authentication",DIAMEAP_EXTENSION);
+			CHECK_FCT_DO(diameap_eap_statemachine(&diameap_sm->eap_sm, &eap_i,&non_fatal_error),
+					{	TRACE_DEBUG(INFO,"%s EAP process failed.",DIAMEAP_EXTENSION); goto s_end;});
+
+			if (non_fatal_error == TRUE)
+			{
+				TRACE_DEBUG(FULL+1,"%sAuthentication verify finished with a non-fatal-error.",DIAMEAP_EXTENSION);
+				diameap_sm->state = DIAMEAP_SEND_ERROR_MSG;
+			}
+			else
+			{
+				diameap_sm->state = DIAMEAP_SELECT_DECISION;
+
+			}
+		}
+			break;
+
+		case DIAMEAP_SELECT_DECISION:
+
+			CHECK_FCT_DO( diameap_policy_decision(diameap_sm,eap_i),
+					goto s_end)
+			;
+
+			if ((eap_i.aaaSuccess == TRUE) && (diameap_sm->auth_request_val
+					== AUTHORIZE_AUTHENTICATE)
+					&& (diameap_sm->verify_authorization == FALSE))
+			{
+				diameap_sm->state = DIAMEAP_AUTHORIZATION_VERIFY;
+			}
+			else
+			{
+				diameap_sm->state = DIAMEAP_DIAMETER_EAP_ANSWER;
+			}
+			break;
+
+		case DIAMEAP_AUTHORIZATION_VERIFY:
+			diameap_sm->verify_authorization = TRUE;
+			TRACE_DEBUG(FULL+1,"%sVerify authorization",DIAMEAP_EXTENSION)
+			;
+			CHECK_FCT_DO(diameap_authorize(diameap_sm),
+					{	TRACE_DEBUG(INFO,"%s Authorization check process failed.",DIAMEAP_EXTENSION); goto s_end;})
+			;
+			diameap_sm->state = DIAMEAP_SELECT_DECISION;
+
+			break;
+
+		case DIAMEAP_DIAMETER_EAP_ANSWER:
+			TRACE_DEBUG(FULL+1,"%screate Diameter EAP Answer",DIAMEAP_EXTENSION)
+			;
+			CHECK_FCT_DO(fd_msg_new_answer_from_req(fd_g_config->cnf_dict, rmsg, 0),
+					goto s_end)
+			;
+			ans = *rmsg;
+			TRACE_DEBUG(FULL+1,"%sAdding AVPs to Diameter EAP Answer.",DIAMEAP_EXTENSION)
+			;
+			CHECK_FCT_DO( diameap_add_avps(diameap_sm, ans,req),
+					{	TRACE_DEBUG(INFO,"%s Unable to add AVPs to Diameter-EAP-Answer message.",DIAMEAP_EXTENSION);goto s_end;})
+			;
+			if (diameap_sm->authFailure == FALSE)
+			{
+				if (diameap_sm->eap_sm.user.id != 0)
+				{
+					TRACE_DEBUG(FULL+1,"%sSelect authentication attributes.",DIAMEAP_EXTENSION);
+					CHECK_FCT_DO(diameap_authentication_get_attribs(diameap_sm->eap_sm.user, &diameap_sm->attributes),
+							{	TRACE_DEBUG(INFO,"%s Unable to get user's session attributes.",DIAMEAP_EXTENSION); goto s_end;});
+					TRACE_DEBUG(FULL+1,"%sCreate answer authentication attributes.",DIAMEAP_EXTENSION);
+					CHECK_FCT_DO(diameap_answer_avp_attributes(diameap_sm),
+							{	TRACE_DEBUG(INFO,"% Unable to generate answer attributes.",DIAMEAP_EXTENSION); goto s_end;});
+				}
+
+				if (diameap_sm->authSuccess == FALSE)
+				{
+					diameap_sm->state = DIAMEAP_SEND_REQUEST;
+				}
+				else
+				{
+
+					diameap_sm->state = DIAMEAP_SEND_SUCCESS;
+				}
+			}
+			else
+			{
+				diameap_sm->state = DIAMEAP_SEND_FAILURE;
+			}
+			break;
+
+		case DIAMEAP_SEND_REQUEST:
+			TRACE_DEBUG(FULL+1,"%sAdding Result Code AVP to Diameter-EAP-Answer.",DIAMEAP_EXTENSION)
+			;
+			CHECK_FCT_DO( diameap_add_result_code(diameap_sm, ans, sess),
+					{	TRACE_DEBUG(INFO,"%s Adding Result-Code AVP failed.",DIAMEAP_EXTENSION); goto s_end;})
+			;
+			TRACE_DEBUG(FULL+1,"%sAdding EAP-Payload to Diameter-EAP-Answer.",DIAMEAP_EXTENSION)
+			;
+			CHECK_FCT_DO( diameap_add_eap_payload(diameap_sm, ans,eap_i),
+					{	TRACE_DEBUG(INFO,"%s Adding EAP-Payload AVP failed.",DIAMEAP_EXTENSION); goto s_end;})
+			;
+			TRACE_DEBUG(FULL+1,"%sStoring DiamEAP session data.",DIAMEAP_EXTENSION)
+			;
+			CHECK_MALLOC(diameap_sess_data = malloc(sizeof(struct diameap_sess_data_sm)))
+			;
+			memset(diameap_sess_data, 0, sizeof(struct diameap_sess_data_sm));
+			diameap_sess_data_new(diameap_sess_data, diameap_sm);
+
+			CHECK_FCT_DO(fd_sess_state_store(diameap_server_reg, sess, &diameap_sess_data),
+					{	TRACE_DEBUG(INFO,"%s Storing session state failed.",DIAMEAP_EXTENSION); goto s_end;})
+			;
+
+			CHECK_FCT_DO( diameap_send(rmsg),
+					goto s_end)
+			;
+
+			diameap_sm->state = DIAMEAP_IDLE;
+			break;
+
+		case DIAMEAP_SEND_FAILURE:
+			TRACE_DEBUG(FULL+1,"%sAdding Result Code AVP to Diameter-EAP-Answer.",DIAMEAP_EXTENSION)
+			;
+			CHECK_FCT_DO( diameap_add_result_code(diameap_sm, ans, sess),
+					{	TRACE_DEBUG(INFO,"%s Adding Result-Code AVP failed.",DIAMEAP_EXTENSION); goto s_end;})
+			;
+			TRACE_DEBUG(FULL+1,"%sAdding EAP-Payload to Diameter-EAP-Answer.",DIAMEAP_EXTENSION)
+			;
+			CHECK_FCT_DO( diameap_add_eap_payload(diameap_sm, ans,eap_i),
+					{	TRACE_DEBUG(INFO,"%s Adding EAP-Payload AVP failed.",DIAMEAP_EXTENSION); goto s_end;})
+			;
+
+			CHECK_FCT_DO( diameap_send(rmsg),
+					goto s_end)
+			;
+			diameap_sm->state = DIAMEAP_END;
+			break;
+
+		case DIAMEAP_SEND_SUCCESS:
+			TRACE_DEBUG(FULL+1,"%sAdding User session AVPs to Diameter-EAP-Answer.",DIAMEAP_EXTENSION)
+			;
+			CHECK_FCT_DO(diameap_add_user_sessions_avps(diameap_sm,ans),
+					{	TRACE_DEBUG(INFO,"%s Adding user's session AVPs failed.",DIAMEAP_EXTENSION); goto s_end;})
+			;
+
+			if (diameap_sm->auth_request_val == AUTHORIZE_AUTHENTICATE)
+			{
+				TRACE_DEBUG(FULL+1,"%sAdding Authorization AVPs to Diameter-EAP-Answer.",DIAMEAP_EXTENSION);
+				CHECK_FCT_DO(diameap_add_authorization_avps(diameap_sm,ans),
+						{	TRACE_DEBUG(INFO,"%s Adding Authorization AVPs failed.",DIAMEAP_EXTENSION); goto s_end;});
+			}
+			TRACE_DEBUG(FULL+1,"%sAdding Result Code AVP to Diameter-EAP-Answer.",DIAMEAP_EXTENSION)
+			;
+			CHECK_FCT_DO( diameap_add_result_code(diameap_sm, ans, sess),
+					{	TRACE_DEBUG(INFO,"%s Adding Result-Code AVP failed.",DIAMEAP_EXTENSION); goto s_end;})
+			;
+			TRACE_DEBUG(FULL+1,"%sAdding EAP-Payload to Diameter-EAP-Answer.",DIAMEAP_EXTENSION)
+			;
+			CHECK_FCT_DO( diameap_add_eap_payload(diameap_sm, ans,eap_i),
+					{	TRACE_DEBUG(INFO,"%s Adding EAP-Payload AVP failed.",DIAMEAP_EXTENSION); goto s_end;})
+			;
+			TRACE_DEBUG(FULL+1,"%sAdding EAP success AVPs AVPs to Diameter-EAP-Answer.",DIAMEAP_EXTENSION)
+			;
+			CHECK_FCT_DO( diameap_add_eap_success_avps(diameap_sm, ans, eap_i),
+					goto s_end)
+			;
+			TRACE_DEBUG(FULL+1,"%sAdding Accounting-EAP-Auth-Method AVPs to Diameter-EAP-Answer.",DIAMEAP_EXTENSION)
+			;
+			CHECK_FCT_DO(diameap_add_accounting_eap_auth_method(diameap_sm, ans),
+					{	TRACE_DEBUG(INFO,"%s Adding accounting AVP failed",DIAMEAP_EXTENSION); goto s_end;})
+			;
+			CHECK_FCT_DO( diameap_send(rmsg),
+					goto s_end)
+			;
+			diameap_sm->state = DIAMEAP_END;
+			break;
+
+		case DIAMEAP_SEND_ERROR_MSG:
+			diameap_sm->invalid_eappackets++;
+			if (diameap_sm->invalid_eappackets
+					== diameap_config->max_invalid_eap_packet)
+			{
+				diameap_sm->result_code = 4001;//DIAMETER_AUTHENTICATION_REJECTED
+				TRACE_DEBUG(FULL,"%s Maximum permitted invalid EAP Packet reached. Diameter Authentication Rejected.",DIAMEAP_EXTENSION);
+			}
+
+			CHECK_FCT_DO(fd_msg_new_answer_from_req(fd_g_config->cnf_dict, rmsg, 0),
+					goto s_end)
+			;
+
+			ans = *rmsg;
+			CHECK_FCT_DO( diameap_add_avps(diameap_sm, ans,req),
+					{	TRACE_DEBUG(INFO,"%s Adding AVPs to Diameter-EAP-Answer message failed.",DIAMEAP_EXTENSION);goto s_end;})
+			;
+			if ((non_fatal_error == TRUE) && (diameap_sm->result_code == 0))
+			{
+				diameap_sm->result_code = 1001;
+			}
+
+			if (diameap_sm->result_code == 1001)
+			{
+				CHECK_FCT_DO( diameap_add_eap_reissued_payload(ans,req), goto s_end);
+			}
+
+			if (diameap_sm->result_code == 5004)
+			{
+				CHECK_FCT_DO( fd_msg_avp_add( ans , MSG_BRW_LAST_CHILD, diameap_sm->failedavp ),goto s_end );
+			}
+
+			CHECK_FCT_DO( diameap_add_result_code(diameap_sm, ans, sess), goto s_end)
+			;
+
+			CHECK_FCT_DO( diameap_send(rmsg), goto s_end)
+			;
+			diameap_sm->state = DIAMEAP_IDLE;
+			break;
+
+		case DIAMEAP_END:
+			break;
+
+		case DIAMEAP_IDLE:
+			break;
+		}
+	}
+
+	diameap_free(diameap_sm);
+
+	s_end: return 0;
+}
+
 int diameap_start_server(void)
 {
 	struct disp_when when;
-	int ret;
+
 	/*create handler for sessions */
 	CHECK_FCT(fd_sess_handler_create(&diameap_server_reg, diameap_cli_sess_cleanup));
@@ -3339,46 +3400,4 @@
 }
 
-static void free_attrib(struct auth_attribute * auth_attrib)
-{
-	if (auth_attrib == NULL)
-	{
-		return;
-	}
-	if (auth_attrib->attrib != NULL)
-	{
-		free(auth_attrib->attrib);
-		auth_attrib->attrib = NULL;
-	}
-	if (auth_attrib->op != NULL)
-	{
-		free(auth_attrib->op);
-		auth_attrib->op = NULL;
-	}
-	if (auth_attrib->value != NULL)
-	{
-		free(auth_attrib->value);
-		auth_attrib->value = NULL;
-	}
-	free(auth_attrib);
-	auth_attrib = NULL;
-}
-
-static void free_avp_attrib(struct avp_attribute * avp_attrib)
-{
-	free(avp_attrib);
-	avp_attrib = NULL;
-}
-
-static void free_ans_attrib(struct avp_attribute * ans_attrib)
-{
-	if (ans_attrib->tofree == 1)
-	{
-		free(ans_attrib->value.os.data);
-		ans_attrib->value.os.data = NULL;
-	}
-	free(ans_attrib);
-	ans_attrib = NULL;
-}
-
 int diameap_stop_server(void)
 {
Index: extensions/app_diameap/diameap_server.h
===================================================================
--- extensions/app_diameap/diameap_server.h	(revision 425)
+++ extensions/app_diameap/diameap_server.h	(revision 438)
@@ -40,9 +40,4 @@
 #define DIAMEAP_SERVER_H_
 
-/* handler for DiamEAP server callback */
-static struct disp_hdl * handle;
-
-/* session handler for DiamEAP sessions state machine */
-static struct session_handler * diameap_server_reg = NULL;
 
 /* session data structure to store */
@@ -120,43 +115,43 @@
 int diameap_stop_server(void);
 
-/* Initialize DiamEAP state machine variables */
+/* Initialize DiamEAP state machine variables
 static int diameap_initialize_diameap_sm(
 		struct diameap_state_machine * diameap_sm,
 		struct diameap_sess_data_sm * diameap_sess_data);
 
-/* Initialize interface between the diameap and the eap states machines */
+ Initialize interface between the diameap and the eap states machines
 static int diameap_initialize_diameap_eap_interface(
 		struct diameap_eap_interface * eap_i);
 
-/* Parse received message */
+ Parse received message
 static int diameap_parse_avps(struct diameap_state_machine * diameap_sm,
 		struct msg * req, struct diameap_eap_interface * eap_i);
 
-/* Add an avp to Failed_AVP AVP for answer message */
+ Add an avp to Failed_AVP AVP for answer message
 static int diameap_failed_avp(struct diameap_state_machine * diameap_sm,
 		struct avp * invalidavp);
 
-/* Parse EAP Response */
+ Parse EAP Response
 static int diameap_parse_eap_resp(struct eap_state_machine * eap_sm,
 		struct eap_packet eappacket);
 
-/* */
+
 static int diameap_eappacket_new(struct eap_packet * eapPacket,
 		struct avp_hdr * avpdata);
 
-/* */
+
 static int diameap_sess_data_new(
 		struct diameap_sess_data_sm *diameap_sess_data,
 		struct diameap_state_machine *diameap_sm);
 
-/* */
+
 static int diameap_unlink_attributes_lists(
 		struct diameap_state_machine * diameap_sm);
 
-/**/
+
 static int diameap_answer_avp_attributes(
 		struct diameap_state_machine * diameap_sm);
 
-/**/
+
 static int diameap_answer_authorization_attributes(
 		struct diameap_state_machine * diameap_sm);
@@ -166,66 +161,66 @@
 static void free_ans_attrib(struct avp_attribute * ans_attrib);
 
-/* */
+
 static int diameap_get_avp_attribute(struct fd_list * avp_attributes,
 		char * attribute, struct avp_attribute ** avp_attrib, int unlink,
 		int *ret);
 
-/* */
+
 static int diameap_get_auth_attribute(struct fd_list * auth_attributes,
 		char * attribute, struct auth_attribute ** auth_attrib, int unlink,
 		int *ret);
 
-/**/
+
 static int diameap_get_ans_attribute(struct fd_list * ans_attributes,
 		char * attribute, struct avp_attribute ** ans_attrib, int unlink,
 		int *ret);
 
-/* */
+
 static int diameap_policy_decision(struct diameap_state_machine * diameap_sm,
 		struct diameap_eap_interface eap_i);
 
-/* */
+
 static int diameap_add_avps(struct diameap_state_machine * diameap_sm,
 		struct msg * ans, struct msg * req);
 
-/* */
+
 static int diameap_add_user_sessions_avps(
 		struct diameap_state_machine * diameap_sm, struct msg * ans);
 
-/* */
+
 static int diameap_add_result_code(struct diameap_state_machine * diameap_sm,
 		struct msg * ans, struct session * sess);
 
-/* */
+
 static int diameap_add_eap_payload(struct diameap_state_machine * diameap_sm,
 		struct msg * ans, struct diameap_eap_interface eap_i);
 
-/* */
+
 static int diameap_add_authorization_avps(struct diameap_state_machine * diameap_sm,
 		struct msg * ans);
 
-/* */
+
 static int diameap_send(struct msg ** rmsg);
 
-/* */
+
 static int diameap_add_eap_success_avps(
 		struct diameap_state_machine * diameap_sm, struct msg * ans,
 		struct diameap_eap_interface eap_i);
 
-/* */
+
 void diameap_cli_sess_cleanup(void * arg, char * sid);
 
-/* */
+
 static void diameap_free(struct diameap_state_machine * diameap_sm);
 
-/* */
+
 static void diameap_sess_data_free(
 		struct diameap_sess_data_sm * diameap_sess_data);
 
-/* */
+
 static int diameap_add_accounting_eap_auth_method(
 		struct diameap_state_machine * diameap_sm, struct msg * ans);
 
-/* */
-static int diameap_add_eap_reissued_payload(struct msg * ans,struct msg * req);
+
+static int diameap_add_eap_reissued_payload(struct msg * ans,struct msg * req);*/
 #endif /* DIAMEAP_SERVER_H_ */
Index: extensions/app_diameap/diameap_tls.c
===================================================================
--- extensions/app_diameap/diameap_tls.c	(revision 425)
+++ extensions/app_diameap/diameap_tls.c	(revision 438)
@@ -39,4 +39,6 @@
 #include "diameap_tls.h"
 
+//GCRY_THREAD_OPTION_PTHREAD_IMPL;
+
 int diameap_tls_init(struct tls_config * tls_conf)
 {
@@ -102,5 +104,5 @@
 	if (text == NULL)
 		return;
-	msg = strdup(text);
+	msg = (u8 *) strdup(text);
 	int i;
 	for (i = 0; (G8(text+i) != '\n') && (G8(text+i) != '\0'); i++)
@@ -170,8 +172,5 @@
 		size_t length)
 {
-	int i;
 	struct tls_data * data = (struct tls_data *) ptr;
-	u8 * buff;
-
 	data->tlsReq.data = realloc(data->tlsReq.data, data->tlsReq.datalength
 			+ length);
@@ -251,5 +250,5 @@
 
 int diameap_tls_get_data(struct tls_msg tlsmsg, u8** tls_data,
-		int * data_length)
+		u32 * data_length)
 {
 	if (tlsmsg.datalength > 0)
@@ -332,5 +331,5 @@
 
 	if (data == NULL)
-		return;
+		return EINVAL;
 	int pos = 0;
 	diameap_tls_new(tlsmsg);
Index: extensions/app_diameap/diameap_tls.h
===================================================================
--- extensions/app_diameap/diameap_tls.h	(revision 425)
+++ extensions/app_diameap/diameap_tls.h	(revision 438)
@@ -46,5 +46,4 @@
 #include <pthread.h>
 
-GCRY_THREAD_OPTION_PTHREAD_IMPL;
 
 
@@ -96,5 +95,5 @@
 int diameap_tls_set_flags(struct tls_msg * tlsmsg, u8 flags);
 
-int diameap_tls_get_data(struct tls_msg tlsmsg, u8** tls_data, int * data_length);
+int diameap_tls_get_data(struct tls_msg tlsmsg, u8** tls_data, u32 * data_length);
 int diameap_tls_set_data(struct tls_msg * tlsmsg, u8* tls_data, int data_length);
 
Index: extensions/app_diameap/plugins.h
===================================================================
--- extensions/app_diameap/plugins.h	(revision 425)
+++ extensions/app_diameap/plugins.h	(revision 438)
@@ -44,10 +44,10 @@
 
 
-static struct register_plugin *registerplugin = NULL;
 
-static int isregistered = 0;
 
 /* Macro that define the register functions of an EAP method */
 #define REGISTER_METHOD(_methodName, _configFunction, _initFunction, _initPickUpFunction, _buildReqFunction, _getTimeoutFunction, _checkFunction, _processFunction, _isDoneFunction, _getKeyFunction, _unregisterFunction, _datafreeFunction  ) \
+static struct register_plugin *registerplugin = NULL;	\
+static int isregistered = 0;	\
 int diameap_plugin_register() {	\
 		if (!isregistered){	\
Index: extensions/app_diameap/plugins/CMakeLists.txt
===================================================================
--- extensions/app_diameap/plugins/CMakeLists.txt	(revision 431)
+++ extensions/app_diameap/plugins/CMakeLists.txt	(revision 438)
@@ -14,8 +14,8 @@
 
 # EAP Identity plugin
-OPTION(BUILD_IDENTITY "Build EAP Identity Plugin " ON)
-	IF (BUILD_IDENTITY)
+OPTION(BUILD_EAP_IDENTITY "Build EAP Identity Plugin " ON)
+	IF (BUILD_EAP_IDENTITY)
 	   ADD_SUBDIRECTORY(eap_identity)
-	ENDIF (BUILD_IDENTITY)
+	ENDIF (BUILD_EAP_IDENTITY)
 
 # EAP MD5 plugin
Index: extensions/app_diameap/plugins/eap_identity/eap_identity.c
===================================================================
--- extensions/app_diameap/plugins/eap_identity/eap_identity.c	(revision 425)
+++ extensions/app_diameap/plugins/eap_identity/eap_identity.c	(revision 438)
@@ -136,5 +136,5 @@
 		goto end;
 	}
-	U8COPY(user,0,len,Respdata);
+	U8COPY((u8 *)user,0,len,Respdata);
 	user[length-5]='\0';
 
Index: extensions/app_diameap/plugins/eap_tls/eap_tls.h
===================================================================
--- extensions/app_diameap/plugins/eap_tls/eap_tls.h	(revision 425)
+++ extensions/app_diameap/plugins/eap_tls/eap_tls.h	(revision 438)
@@ -47,4 +47,5 @@
 int diameap_eap_tls_buildReq_data(struct tls_data * data,int id,struct eap_packet * eapPacket);
 int diameap_eap_tls_parse(struct tls_msg * eaptls,struct eap_packet eapPacket);
+int eaptlsparse(struct tls_config * conf);
 
 #endif /* EAP_TLS_H_ */
Index: extensions/app_diameap/plugins/eap_tls/eaptls.l
===================================================================
--- extensions/app_diameap/plugins/eap_tls/eaptls.l	(revision 425)
+++ extensions/app_diameap/plugins/eap_tls/eaptls.l	(revision 438)
@@ -47,4 +47,6 @@
 	yylloc->last_column += yyleng +1;	\
 	}	 
+	
+#define YY_NO_INPUT
 %}
 
@@ -53,5 +55,5 @@
 %option bison-bridge 
 %option bison-locations
-
+%option nounput
 %%
 	/* List of patterns and actions */
Index: extensions/app_diameap/plugins/eap_tls/eaptls.y
===================================================================
--- extensions/app_diameap/plugins/eap_tls/eaptls.y	(revision 425)
+++ extensions/app_diameap/plugins/eap_tls/eaptls.y	(revision 438)
@@ -127,5 +127,5 @@
 		if (fl == NULL) {
 			int ret = errno;
-			TRACE_DEBUG(INFO,"%s[EAP TLS plugin] Unable to open certificate file %s for reading",DIAMEAP_EXTENSION,certfile);
+			TRACE_DEBUG(INFO,"%s[EAP TLS plugin] Unable to open certificate file %s for reading: %s",DIAMEAP_EXTENSION,certfile,strerror(ret));
 			yyerror (&yylloc, config, "Error configuring certificate for EAP-TLS"); 
 			YYERROR;
@@ -144,5 +144,5 @@
 		if (fl == NULL) {
 			int ret = errno;
-			TRACE_DEBUG(INFO,"%s[EAP TLS plugin] Unable to open privateKey file %s for reading",DIAMEAP_EXTENSION,keyfile);
+			TRACE_DEBUG(INFO,"%s[EAP TLS plugin] Unable to open privateKey file %s for reading: %s",DIAMEAP_EXTENSION,keyfile,strerror(ret));
 			yyerror (&yylloc, config, "Error configuring privateKey for EAP-TLS"); 
 			YYERROR;
@@ -179,5 +179,5 @@
 		if (fl == NULL) {
 			int ret = errno;
-			TRACE_DEBUG(INFO,"%s[EAP TLS plugin] Unable to open CA file %s for reading",DIAMEAP_EXTENSION,cafile);
+			TRACE_DEBUG(INFO,"%s[EAP TLS plugin] Unable to open CA file %s for reading: %s",DIAMEAP_EXTENSION,cafile,strerror(ret));
 			yyerror (&yylloc, config, "Error configuring CA file for EAP-TLS"); 
 			YYERROR;
@@ -211,5 +211,5 @@
 			if (fl == NULL) {
 				int ret = errno;
-				TRACE_DEBUG(INFO,"%s[EAP TLS plugin] Unable to open CRL file %s for reading",DIAMEAP_EXTENSION,crlfile);
+				TRACE_DEBUG(INFO,"%s[EAP TLS plugin] Unable to open CRL file %s for reading: %s",DIAMEAP_EXTENSION,crlfile,strerror(ret));
 				yyerror (&yylloc, config, "Error configuring CRL file for EAP-TLS"); 
 				YYERROR;
